const List = {};

List.append = (item) => (arr) => arr.concat([item]);
List.compact = (arr) => arr.filter((x) => x !== null && x !== undefined);
List.filter = (filterer) => (arr) => arr.filter(filterer);
List.head = (arr) => arr[0];
List.indexOf = (item) => (arr) => arr.indexOf(item);
List.includes = (item) => (arr) => arr.indexOf(item) > -1;
List.insertAt = (index) => (item) => (arr) => {
	const copy = arr.slice();
	copy.splice(index, 0, item);
	return copy;
};
List.isEmpty = (arr) => arr.length === 0;
List.join = (joiner) => (arr) => arr.join(joiner);
List.last = (arr) => arr[arr.length - 1];
List.length = (arr) => arr.length;
List.prepend = (item) => (arr) => [item].concat(arr);
List.reduce = (fn) => (arr) => arr.reduce(fn);
List.reduceWithInitial = (fn) => (initialValue) => (arr) => arr.reduce(fn, initialValue);
List.reverse = (arr) => arr.slice().reverse();
List.slice = (start) => (end) => (arr) => arr.slice(start, end);
List.sort = (sorter) => (arr) => arr.slice().sort(sorter);

module.exports = List;